/*
 * Exemplo de uso de clone.
 */ 


#include <sched.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#define STACK_SIZE 4096
 
int f(void* v) {
  printf ("Clone!\n");
  return 0;
}

int main() {

  char* stack = malloc(STACK_SIZE);
  char* topo = ((char*) stack) + STACK_SIZE - 1;
  if (clone(f, topo, 0, NULL) == -1) 
    perror("Clone");

  wait(NULL);
 
  return 0;
}  
  
